//*******************************************************
//
//	SM9501A + 7SEG LED dgv
//
//	MCU:ATmega88/168
//		efuse:0xF9
//		hfuse:0xD6	BOD 1.8V EEPROMی
//		lfuse:0xE2	CRU 8MHz
//
//	Compiler:	AVR-GCC		4.2.2
//				AVR-LIBC	1.4.7
//				binutils	2.18
//
//	2008.7.7	␳l30bȏقȂꍇ͍ēx
//	2008.7.6	␳lRTCƁ}PȏقȂꍇ͍ēx
//	2008.6.29	KAWAKAMI Yukio
//
//	New BSD license
//*******************************************************

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>
#include	<avr/pgmspace.h>
#include	<util/parity.h>
#include	<util/twi.h>
#include	<stdlib.h>
#include	<string.h>

#include	"RCL1.h"

#define		NOIZE_LEVEL		10		// mCYx 1`30
#define		MENU_TIMEOUT	15		// j[^CAEg(b)

#define		USE_TR			1		// TR1`5gꍇ 1
									// g킸 CPU 7SEG̏ꍇ 0

// tHg	CPU̃RlN^zԈႦ̂ŕsKɂȂĂ orz
PROGMEM uchar NumFont[16] = {
	0x77, 0x12, 0x6B, 0x3B, 0x1E, 0x3D, 0x7D, 0x17, 0x7F, 0x3F,
	0x5F, 0x7C, 0x65, 0x7A, 0x6D, 0x4D };

PROGMEM char MonthDays[]
	= { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };


uchar	JJY60flag;				// JJY 60kHztO
uchar	Time12flag;				// 12ԕ\tO
uchar	SegDuty;				// 7SEG LED DUTY(5`100%)
uchar	AlarmHour;				// A[()
uchar	AlarmMin;				// A[()
uchar	AlarmFlag;				// A[LtO
uchar	AlarmOn;

volatile uchar	Timer;			// ėp^C}
volatile uchar	MenuTimer;		// j[^C}
volatile char	SW1flag;		// SW1ꂽ
volatile char	SW2flag;		// SW2ꂽ

volatile uchar	SegData[5];		// 7SEG LEDobt@
volatile uchar	SegNo;
volatile char	StopScanFlag;	// LEDXL~tO

volatile uchar	JJYtimer;		// JJY␳^C}

volatile uchar	JJYok;			// JJYM
volatile uchar	JJYbuff[8];		// dgvMf[^obt@
volatile uchar	JJYflag;		// JJYMオtO
volatile char	JJYTimeout;		// JJY^CAEg


//*******************************************************
//	^C}[Orv`荞
//	4kHzŌĂяoAA[炷
//*******************************************************
ISR(TIMER0_COMPA_vect){
	static uint	count;
	static uchar count2;

	if (++count < 400){
		if (count2 < 4){		// 41x
			if (count & 1){
				PORTD |= (1<<TXD);
				PORTD &= ~(1<<RXD);
			} else {
				PORTD &= ~(1<<TXD);
				PORTD |= (1<<RXD);
			}
		}
	} else if (count == 400){
		PORTD |= (1<<TXD)|(1<<RXD);
		DDRD &= ~((1<<TXD)|(1<<RXD));
	} else if (count == 800){
		count = 0;
		if (++count2 >= 5){
			count2 = 0;
		}
		if (count2 < 4){
			DDRD |= (1<<TXD)|(1<<RXD);
		}
	}
}


//*******************************************************
//	^C}[Prv`荞
//	2MHz / 20000 = 100Hz
//*******************************************************
ISR(TIMER1_COMPA_vect){
	static char	old_sw1 = 0;
	static char old_sw2 = 0;
	char	s;

	if (Timer)	--Timer;
	if (MenuTimer){
		static uchar count = 0;

		if (++count >= 100){
			count = 0;
			--MenuTimer;
		}
	}

	// XCb`Ď
	s = CHECK_SW1;
	if (!old_sw1 && s){
		SW1flag = 1;
	}
	old_sw1 = s;

	s = CHECK_SW2;
	if (!old_sw2 && s){
		SW2flag = 1;
	}
	old_sw2 = s;
	
	// JJYM
	if (JJYtimer){
		static uchar	jjy_timer_count;
		static uchar	state;
		static uchar	bit;
		static uchar	interval;
		static uchar	width;
		static uchar	width_flag;
		uchar	p;

		// v^CAEg
		if (++jjy_timer_count >= 100){
			jjy_timer_count = 0;
			--JJYtimer;
			if (!JJYtimer){
				JJYTimeout = 1;
				StopScanFlag = 0;	// 7SEG LEDXL~܂ĂĊJ
			}
		}
		
		// dgv̐M
		if (JJY_ON){
			p = 1;
		} else {
			p = 0;
		}

		if (interval < 255)	interval++;
		
		if (state == 0){
			// Mオ茟o
			if (p){
				bit = 0;
				state++;
				if ((interval >= 98)&&(interval <= 102)){
					// PbɐMĂ
					if (JJYok < 4)	JJYok++;
				}
				interval = 0;
				width = 0;
				width_flag = 1;
			}
		} else if (state < 90){
			state ++;
			if (p){
				if (width_flag)	width++;	// M̕
				if ((state >= 52)&&(state < 82)){
					bit++;			// 520`820̊ԂŐM邩
				}
			} else {
				width_flag = 0;		// Mr؂ꂽ
			}
		} else if (state == 90) {
			uchar	i;

			state++;

			// MMԂ𐄑
			if ((width < 15)||
				((width > 25)&&(width < 45))||
				((width > 55)&&(width < 75))||
				(width > 85)){
				if (JJYok > 0)	--JJYok;
			}
			
			// f[^Vtg
			for (i = 0; i < 7; i++){
				JJYbuff[i] <<= 1;
				JJYbuff[i] |= (JJYbuff[i+1] >> 7);
			}
			JJYbuff[7] <<= 1;
			if (bit < NOIZE_LEVEL){
				JJYbuff[7] |= 0x10;		// 1
			}
			// }XNƔrē
			if (((JJYbuff[0] & 0x88) == 0x80)&&
				((JJYbuff[1] & 0x72) == 0x40)&&
				((JJYbuff[2] & 0x1C) == 0x10)&&
				((JJYbuff[3] & 0x84) == 0x04)&&
				((JJYbuff[4] & 0x31) == 0x01)&&
				((JJYbuff[6] & 0x41) == 0x40)&&
				((JJYbuff[7] & 0xF0) == 0x10)){
				uchar	data;

				JJYflag = 1;	// C[`ŃfR[h

				// peB`FbN
				data = (JJYbuff[0] & 0x70)|((JJYbuff[0] & 0x07)<<1)|(JJYbuff[1]>>7);
				data = parity_even_bit(data);
				data ^= ((JJYbuff[4] & 0x04)>>2);
				if (data)	JJYflag = 0;	// peBG[

				// peB`FbN
				data = ((JJYbuff[1] & 0x0C)<<2)|((JJYbuff[1] & 0x01)<<3)|((JJYbuff[2] & 0xE0)>>5);
				data = parity_even_bit(data);
				data ^= ((JJYbuff[4] & 0x08)>>3);
				if (data)	JJYflag = 0;	// peBG[
			}
		} else {
			// MOFF҂
			if (!p){
				state = 0;
			}
		}

	}
}


//*******************************************************
//	^C}[Qrv`荞
//	2MHz / 256 / 20 = 390Hz
//*******************************************************
ISR(TIMER2_COMPA_vect){

	if (!StopScanFlag){
		uchar	d;
		// 7SEG LED _Ci~bNXL
#if USE_TR
		PORTD |= (1<<COM5)|(1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1);
#else
		PORTD &= ~((1<<COM5)|(1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1));
#endif
		if (++SegNo >= 5){

			SegNo = 0;

		} else if (SegNo == 4){

			if (JJYtimer && JJY_ON){
				SegData[4] |= LED_JJY;		// JJY LED_
			} else {
				SegData[4] &= ~LED_JJY;
			}

		}
		d = SegData[SegNo];
		PORTB = ~d;
		if (d){		// \ZOgꍇ̓x[Xd𗬂Ȃ
#if USE_TR
			PORTD &= ~((1<<(COM1 + SegNo)));
#else
			PORTD |= (1<<(COM1 + SegNo));
#endif
		}

	} else {
		// 7SEG LED XL~BƃmCY
#if USE_TR
		PORTD |= (1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1);
		PORTD &= ~(1<<COM5);
#else
		PORTD &= ~((1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1));
		PORTD |= (1<<COM5);
#endif
		if (JJYtimer && JJY_ON){
			PORTB = ~LED_JJY;		// JJY LED̂ݓ_
		} else {
			PORTB = 0xFF;
		}
	}
}


//*******************************************************
//	^C}[Qrva荞
//	2MHz / 256 / 20 = 390Hz
//*******************************************************
ISR(TIMER2_COMPB_vect){

	// 7SEG LED ̊荞݂̃^C~O LED̖邳𒲐
#if USE_TR
	PORTD |= (1<<COM5)|(1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1);
#else
	PORTD &= ~((1<<COM5)|(1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1));
#endif
	PORTB = 0xFF;
}


//*******************************************************
//	C[`
//*******************************************************
int main (void) {
	uchar	old_sec = 0;
	uchar	view_alarm = 0;
	uchar	n;
	struct RTC_TIME	rtc, jjy, old_jjy;

	cli();

	CLKPR = (1<<CLKPCE);
	CLKPR = (1<<CLKPS1);	// 4 2MHz
	
	PORTB = 0;
	DDRB = 0xFF;

#if USE_TR
	PORTD = (1<<COM5)|(1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1)
		|(1<<SW1_PORT)|(1<<TXD)|(1<<RXD);
#else
	PORTD = (1<<SW1_PORT)|(1<<TXD)|(1<<RXD);
#endif
	DDRD = (1<<COM5)|(1<<COM4)|(1<<COM3)|(1<<COM2)|(1<<COM1);

	PORTC = (1<<SCL)|(1<<SDA)|(1<<SW2_PORT);
	DDRC = (1<<PON);

	// ^C}P 100Hz荞
	TCCR1A = 0;
	TCCR1B = (1<<WGM12)|(1<<CS10);	// CTC vXP[Ȃ
	TCCR1C = 0;
	OCR1AH = (20000 - 1) >> 8;
	OCR1AL = (uchar)(20000 - 1);	// 2MHz / 20000 = 100Hz
	TIMSK1 = (1<<OCIE1A);			// r1A荞݋

	// ^C}Q 390Hz荞
	TCCR2A = (1<<WGM21);			// CTC
	TCCR2B = (1<<CS22)|(1<<CS21);	// vXP[ 256
	OCR2A = 20 - 1;					// 2MHz / 256 / 20 = 390Hz
	OCR2B = 0;						// 7SEG LED 邳 5%
	TIMSK2 = (1<<OCIE2B)|(1<<OCIE2A);	// rv`Ca荞݋

	// X[v
	MCUCR = (1<<SE);		// X[vAACh[h

	// ^C}0, SPI, ADC, USART d̓Jbg
	PRR = (1<<PRTIM0)|(1<<PRSPI)|(1<<PRADC)|(1<<PRUSART0);
	ACSR = (1<<ADC);	// AiORp[^֎~
	
	// EEPROMݒlǂݍ
	JJY60flag = eeprom_read_byte(EEPROM_JJY60);
	if (JJY60flag == 0xFF)	JJY60flag = 0;		// ftHg 40kHz
	Time12flag = eeprom_read_byte(EEPROM_TIME12);
	if (Time12flag == 0xFF)	Time12flag = 0;		// ftHg 24ԕ\
	SegDuty = eeprom_read_byte(EEPROM_DUTY);
	if (SegDuty < 5){
		SegDuty = 5;
	} else if (SegDuty > 100){
		SegDuty = 50;		// ftHg 50%
	}
	AlarmHour = eeprom_read_byte(EEPROM_ALARM_HOUR);
	if (AlarmHour >= 24)	AlarmHour = 0;
	AlarmMin = eeprom_read_byte(EEPROM_ALARM_MIN);
	if (AlarmMin >= 60)		AlarmMin = 0;
	AlarmFlag = eeprom_read_byte(EEPROM_ALARM_FLAG);
	if (AlarmFlag == 0xFF)	AlarmFlag = 0;

	if (JJY60flag){
		FCN_60kHz;
	} else {
		FCN_40kHz;
	}

	set_duty(SegDuty);
	
	sei();

	// TWIZbg?
	TWI_open();
	TWI_write(0xFF);
	TWI_close();
	
	// RTCݒ
	TWI_open();
	TWI_write(0xA2);	// X[uAhX + Write
	TWI_write(0);		// WX^ 0(Control1)
	TWI_write(0);		// NbN
	TWI_close();

	read_RTC(&rtc);

	// N JJY␳ 255b
	JJYtimer = 255;
	if (rtc.year == 0){		// RTCĂɂȂȂȂ
		StopScanFlag = 1;	// 7SEG LEDXL~ē
	}
	
	// C[v
	for (;;){

		WDR;

		// \XV^C~O҂
		Timer = 2;
		while(!JJYflag && Timer){
			SLEEP;

			if (AlarmOn){
				// A[͂ǂ炩̃{^ƒ~
				if (SW1flag || SW2flag){
					AlarmOn = 0;
					alarm_off();		// A[~
				}
			} else {
				if (SW1flag){
					Timer = 100;
					while(Timer){
						SLEEP;
						if (!CHECK_SW1)	break;
					}
					StopScanFlag = 0;		// 7SEG LEDXL~܂ĂĊJ
					SW1flag = 0;
					if (Timer){				// SW2 1bȓ
						MenuTimer = 10;		// 10b \
						view_alarm = 0;
					} else {
						// SW2 1bȏ㒷
						menu();				// ݒ胁j[
						MenuTimer = 0;
						JJYflag = 0;		// 
					}
					old_sec = 99;
					break;
				}
			
				if (SW2flag){
					Timer = 100;
					while(Timer){
						SLEEP;
						if (!CHECK_SW2)	break;
					}
					StopScanFlag = 0;		// 7SEG LEDXL~܂ĂĊJ
					SW2flag = 0;
					if (Timer){				// SW1 1bȓ
						MenuTimer = 10;		// 10b A[\
						view_alarm = 1;
					} else {
						// SW1 1bȏ㒷
						set_alarm();		// A[ݒ
						MenuTimer = 0;
						JJYflag = 0;
					}
					old_sec = 99;
					break;
				}
			}
		}

		if (JJYflag){	// JJY^CR[h擾łB̒iK 59.9b
			char	adjust_flag = 0;

			JJYflag = 0;

			if (rtc.year == 0){
				// RTC̒lĂɂȂȂ̂ JJY擾l̕Mp
				JJY2RTC(&rtc);			// JJYl RTC_TIMEɕϊB[b
				next_min(&rtc);			// 擾l1i߂
				adjust_flag = 1;
			} else {
				struct RTC_TIME	tmp;
				JJY2RTC(&jjy);			// JJYl RTC_TIMEɕϊ
				tmp = jjy;				// tf[^܂߂ĕۑ
				jjy.year = rtc.year;	// tf[^͉Ă邩Ȃ
				jjy.month = rtc.month;	// ̂ RTC̃f[^p
				jjy.day = rtc.day;
				if ((rtc.hour == jjy.hour)&&	// ƕŔr
					(rtc.min == jjy.min)&&
					(rtc.sec >= 0x30)){			// 30bȓ̒x
					next_min(&jjy);		// ̕ɂȂ
					rtc = jjy;			// tύX̉\̂őSRs[
					adjust_flag = 1;
				} else {
					next_min(&jjy);		// ̕Ŕr
					if ((rtc.hour == jjy.hour)&&
						(rtc.min == jjy.min)&&
						(rtc.sec < 0x30)){		// 30bȓ̐i
						rtc.sec = 0;			// [bZbg
						adjust_flag = 1;
					} else {
						next_min(&old_jjy);		// 1Õf[^Ȃ̂Ői߂
						jjy = tmp;				// ۑĂf[^g
						if ((jjy.year == old_jjy.year)&&
							(jjy.month == old_jjy.month)&&
							(jjy.day == old_jjy.day)&&
							(jjy.hour == old_jjy.hour)&&
							(jjy.min == old_jjy.min)){	// 2JJYlv
							next_min(&jjy);
							rtc = jjy;		// tf[^܂߂JJYlZbg
							adjust_flag = 1;
						}
						old_jjy = jjy;	// old_jjy͂̃ubNłgȂ
					}
				}
			}

			if (adjust_flag){

				//  JJYpXオ҂
				while(JJY_ON){ SLEEP; }
				while(!JJY_ON);

				adjust_RTC(&rtc);		// A^CNbNɒlZbg
				JJYtimer = 0;			// JJYݒ芮
				StopScanFlag = 0;		// 7SEG LEDXL~܂ĂĊJ
				old_sec = 99;
			}
		} else if (!StopScanFlag){
			read_RTC(&rtc);			// A^CNbNǂݍ
		}

		if (rtc.sec == old_sec)	continue;	// \XVsv
		old_sec = rtc.sec;

		if (!MenuTimer){
			//  7SEG LEDɃZbg
			set_hour(rtc.hour);
			SegData[2] = (uchar)pgm_read_byte(&(NumFont[rtc.min >> 4]));
			SegData[3] = (uchar)pgm_read_byte(&(NumFont[rtc.min & 0x0F]));
			if (rtc.sec & 1){
				SegData[4] &= ~(LED_C1 | LED_C2);
			} else {
				SegData[4] |= LED_C1 | LED_C2;	// RPbƂɓ_
			}
		} else {
			if (!view_alarm){
				// \
				uchar	month;

				month = rtc.month;
				n = month >> 4;
				if (n){
					SegData[0] = (uchar)pgm_read_byte(&(NumFont[n]));
				} else {
					SegData[0] = 0;		// [TvX
				}
				SegData[1] = (uchar)pgm_read_byte(&(NumFont[month & 0x0F])) | 0x80;
				SegData[2] = (uchar)pgm_read_byte(&(NumFont[rtc.day >> 4]));
				SegData[3] = (uchar)pgm_read_byte(&(NumFont[rtc.day & 0x0F]));
				SegData[4] = 0;
			} else {
				// A[\
				if (!AlarmFlag){		// A[Ȃ
					SegData[0] = 0x08;	// --:-- \
					SegData[1] = 0x08;
					SegData[2] = 0x08;
					SegData[3] = 0x08;
					SegData[4] = 0;
				} else {
					set_hour(AlarmHour);
					SegData[2] = (uchar)pgm_read_byte(&(NumFont[AlarmMin >> 4]));
					SegData[3] = (uchar)pgm_read_byte(&(NumFont[AlarmMin & 0x0F]));
				}
				SegData[4] |= LED_C1 | LED_C2;	// R\
			}
		}

		if ((rtc.min == 0x56)&&(rtc.sec == 0x50)){	// 5650b
			JJYtimer = 140;		//  57`59Ɏ␳
			JJYTimeout = 0;
			memset(&JJYbuff, 0, sizeof(JJYbuff));
		} else if ((rtc.hour == 0x03)&&(rtc.min == 0x24)&&(rtc.sec == 0x50)&&
				   (JJYTimeout)){
			// O̎␳s
			// 03:24:50  LEDXL~߂Ď
			JJYtimer = 255;
			StopScanFlag = 1;
			memset(&JJYbuff, 0, sizeof(JJYbuff));
		}

		if (AlarmFlag && (AlarmHour == rtc.hour)&&(AlarmMin == rtc.min)&&(rtc.sec == 0)){
			// A[
			alarm_on();			// A[
			AlarmOn = 1;
		}
		if (AlarmOn && (AlarmMin != rtc.min)){
			alarm_off();		// uĂ1ŃA[~
			AlarmOn = 0;
		}
	}
}


//*******************************************************
//	ݒ胁j[
//*******************************************************
void menu(void){
	uchar	n;
	uchar	key;

	SegData[4] = 0;
	MenuTimer = MENU_TIMEOUT;
	
	// C1 邳ݒ
	SegData[0] = 0x65;			// C
	SegData[1] = 0x12;			// 1
	n = SegDuty;
	while(MenuTimer){
		SegData[2] = (uchar)pgm_read_byte(&NumFont[(n/10) % 10]);
		SegData[3] = (uchar)pgm_read_byte(&NumFont[n%10]);
		key = inkey();
		if (key == SW1){
			MenuTimer = MENU_TIMEOUT;
			if (SegDuty != n){
				SegDuty = n;
				eeprom_write_byte(EEPROM_DUTY, SegDuty);
				flash();
			}
			break;
		} else if (key == SW2){
			MenuTimer = MENU_TIMEOUT;
			n += 5;
			if (n > 100)	n = 5;
			set_duty(n);
		} else {
			// Time out
			set_duty(SegDuty);
			return;
		}
	}

	
	// C2 40kHz/60kHz I
	SegData[0] = 0x65;			// C
	SegData[1] = 0x6B;			// 2
	n = JJY60flag;
	while(MenuTimer){
		if (n){
			SegData[2] = (uchar)pgm_read_byte(&NumFont[6]);
		} else {
			SegData[2] = (uchar)pgm_read_byte(&NumFont[4]);
		}
		SegData[3] = (uchar)pgm_read_byte(&NumFont[0]);
		key = inkey();
		if (key == SW1){
			MenuTimer = MENU_TIMEOUT;
			if (JJY60flag != n){
				JJY60flag = n;
				eeprom_write_byte(EEPROM_JJY60, JJY60flag);
				flash();
				if (JJY60flag){
					FCN_60kHz;
				} else {
					FCN_40kHz;
				}
			}
			break;
		} else if (key == SW2){
			MenuTimer = MENU_TIMEOUT;
			if (n){
				n = 0;
			} else {
				n = 1;
			}
		} else {
			return;
		}
	}

	// C3 24/12 I
	SegData[0] = 0x65;			// C
	SegData[1] = 0x3B;			// 3
	n = Time12flag;
	while(MenuTimer){
		if (n){
			SegData[2] = (uchar)pgm_read_byte(&NumFont[1]);
			SegData[3] = (uchar)pgm_read_byte(&NumFont[2]);
		} else {
			SegData[2] = (uchar)pgm_read_byte(&NumFont[2]);
			SegData[3] = (uchar)pgm_read_byte(&NumFont[4]);
		}
		key = inkey();
		if (key == SW1){
			MenuTimer = MENU_TIMEOUT;
			if (Time12flag != n){
				Time12flag = n;
				eeprom_write_byte(EEPROM_TIME12, Time12flag);
				flash();
			}
			break;
		} else if (key == SW2){
			MenuTimer = MENU_TIMEOUT;
			if (n){
				n = 0;
			} else {
				n = 1;
			}
		} else {
			return;
		}
	}

	// C4 N(b)ݒ
	SegData[0] = 0x65;			// C
	SegData[1] = 0x1E;			// 3
	n = 0;
	while(MenuTimer){
		if (n){
			SegData[2] = 0x75;	// G
			SegData[3] = 0x78;	// o
		} else {
			SegData[2] = 0x58;	// n
			SegData[3] = 0x78;	// o
		}
		key = inkey();
		if (key == SW1){
			MenuTimer = MENU_TIMEOUT;
			if (n){
				set_time();		// }jAԐݒ
			}
			break;
		} else if (key == SW2){
			MenuTimer = MENU_TIMEOUT;
			if (n){
				n = 0;
			} else {
				n = 1;
			}
		} else {
			return;
		}
	}
}


//*******************************************************
//	A[ݒ
//*******************************************************
void set_alarm(void){
	uchar	h, m, n;
	uchar	buff[2];
	uchar	f = 0;

	h = AlarmHour;
	m = AlarmMin;
	if (h >= 0x24){
		h = 0;
		m = 0;
	}

	SegData[2] = (uchar)pgm_read_byte(&NumFont[m >> 4]);
	SegData[3] = (uchar)pgm_read_byte(&NumFont[m & 0x0F]);

	// 
	MenuTimer = MENU_TIMEOUT;
	while(MenuTimer){
		set_hour(h);
		SegData[4] |= LED_C1 | LED_C2;
		buff[0] = SegData[0];
		buff[1] = SegData[1];
		Timer = 50;
		SW1flag = 0;
		SW2flag = 0;
		while(Timer){
			WDR;
			SLEEP;
			if (!f){
				SegData[0] = buff[0];
				SegData[1] = buff[1];
			} else {
				SegData[0] = 0;
				SegData[1] = 0;
			}
			if (SW1flag){
				SegData[0] = buff[0];
				SegData[1] = buff[1];
				SW1flag = 0;
				SW2flag = 0;
				goto MIN;
			} else if (SW2flag){
				MenuTimer = MENU_TIMEOUT;
				if (++h == 0x0A){
					h = 0x10;
				} else if (h == 0x1A){
					h = 0x20;
				} else if (h >= 0x24){
					h = 0;
				}
				f = 1;
				break;
			}
		}
		f ^= 1;
	}
	if (!MenuTimer)	return;

  MIN:
	// 
	n = m >> 4;
	n = set_digit(n, 2, 0, 5);
	if (n > 9)	return;
	m = (m & 0x0F) | (n << 4);
	n = m & 0x0F;
	n = set_digit(n, 3, 0, 9);
	if (n > 9)	return;
	m = (m & 0xF0) | n;

	AlarmHour = h;
	AlarmMin = m;
	eeprom_write_byte(EEPROM_ALARM_HOUR, AlarmHour);
	eeprom_write_byte(EEPROM_ALARM_MIN, AlarmMin);

	// on/off
	SegData[0] = 0x5F;			// A
	SegData[1] = 0xE4;			// L.
	SegData[2] = 0x78;	// o
	SegData[4] = 0;
	n = AlarmFlag;
	MenuTimer = MENU_TIMEOUT;
	while(MenuTimer){
		uchar	key;

		if (n){
			SegData[3] = 0x58;	// n
		} else {
			SegData[3] = 0x4D;	// F
		}
		key = inkey();
		if (key == SW1){
			if (n != AlarmFlag){
				AlarmFlag = n;
				eeprom_write_byte(EEPROM_ALARM_FLAG, AlarmFlag);
				flash();
			}
			SW1flag = 0;
			SW2flag = 0;
			return;
		} else if (key == SW2){
			MenuTimer = MENU_TIMEOUT;
			if (n){
				n = 0;
			} else {
				n = 1;
			}
		} else {
			break;
		}
	}
}


//*******************************************************
//	}jAԐݒ
//*******************************************************
void set_time(void){
	uchar	n;
	uchar	min, max;
	struct RTC_TIME	rtc;

	read_RTC(&rtc);
	SegData[0] = 0;

	// N
	SegData[1] = 0xBE;			// y.
	SegData[2] = (uchar)pgm_read_byte(&NumFont[rtc.year >> 4]);
	SegData[3] = (uchar)pgm_read_byte(&NumFont[rtc.year & 0x0F]);
	n = rtc.year >> 4;
	n = set_digit(n, 2, 0, 9);
	if (n > 9)	return;
	rtc.year = (rtc.year & 0x0F) | (n << 4);
	n = rtc.year & 0x0F;
	n = set_digit(n, 3, 0, 9);
	if (n > 9)	return;
	rtc.year = (rtc.year & 0xF0) | n;
	
	// 
	SegData[1] = 0xD7;			// M.
	SegData[2] = (uchar)pgm_read_byte(&NumFont[rtc.month >> 4]);
	SegData[3] = (uchar)pgm_read_byte(&NumFont[rtc.month & 0x0F]);
	n = rtc.month >> 4;
	n = set_digit(n, 2, 0, 1);
	if (n > 9)	return;
	rtc.month = (rtc.month & 0x0F) | (n << 4);
	if (n == 0){
		min = 1;
		max = 9;
	} else {
		min = 0;
		max = 2;
	}
	n = rtc.month & 0x0F;
	n = set_digit(n, 3, min, max);
	if (n > 9)	return;
	rtc.month = (rtc.month & 0xF0) | n;
	
	// 
	SegData[1] = 0xFA;			// d.
	SegData[2] = (uchar)pgm_read_byte(&NumFont[rtc.day >> 4]);
	SegData[3] = (uchar)pgm_read_byte(&NumFont[rtc.day & 0x0F]);
	n = rtc.day >> 4;
	if (rtc.month == 2){
		max = 2;
	} else {
		max = 3;
	}
	n = set_digit(n, 2, 0, max);
	if (n > 9)	return;
	rtc.day = (rtc.day & 0x0F) | (n << 4);
	if (n == 0){
		min = 1;	max = 9;
	} else if (n == 1){
		min = 0;	max = 9;
	} else if (n == 2){
		min = 0;
		if ((rtc.month == 2)&&(BIN(rtc.year) % 4) != 0){
			max = 8;
		} else {
			max = 9;
		}
	} else {
		min = 0;
		if ((rtc.month == 4)||
			(rtc.month == 6)||
			(rtc.month == 9)||
			(rtc.month == 0x11)){
			max = 0;
		} else {
			max = 1;
		}
	}
	n = rtc.day & 0x0F;
	n = set_digit(n, 3, min, max);
	if (n > 9)	return;
	rtc.day = (rtc.day & 0xF0) | n;
	
	// 
	SegData[1] = 0xDE;			// H.
	SegData[2] = (uchar)pgm_read_byte(&NumFont[rtc.hour >> 4]);
	SegData[3] = (uchar)pgm_read_byte(&NumFont[rtc.hour & 0x0F]);
	n = rtc.hour >> 4;
	n = set_digit(n, 2, 0, 2);
	if (n > 9)	return;
	rtc.hour = (rtc.hour & 0x0F) | (n << 4);
	if (n == 2){
		min = 0;
		max = 3;
	} else {
		min = 0;
		max = 9;
	}
	n = rtc.hour & 0x0F;
	n = set_digit(n, 3, min, max);
	if (n > 9)	return;
	rtc.hour = (rtc.hour & 0xF0) | n;
	
	// 
	SegData[1] = 0xD8;			// n.
	SegData[2] = (uchar)pgm_read_byte(&NumFont[rtc.min >> 4]);
	SegData[3] = (uchar)pgm_read_byte(&NumFont[rtc.min & 0x0F]);
	n = rtc.min >> 4;
	n = set_digit(n, 2, 0, 5);
	if (n > 9)	return;
	rtc.min = (rtc.min & 0x0F) | (n << 4);
	n = rtc.min & 0x0F;
	n = set_digit(n, 3, 0, 9);
	if (n > 9)	return;
	rtc.min = (rtc.min & 0xF0) | n;

	rtc.sec = 0;		// 00b
	adjust_RTC(&rtc);	// Ԑݒ
}


//*******************************************************
//	Pݒ
//*******************************************************
uchar set_digit(uchar n, uchar keta, uchar min, uchar max){
	uchar	buff;
	uchar	f;
	
	MenuTimer = MENU_TIMEOUT;

	if ((n < min)||(n > max))	n = min;

	f = 0;
	while(MenuTimer){
		buff = (uchar)pgm_read_byte(&NumFont[n]);
		Timer = 50;
		SW1flag = 0;
		SW2flag = 0;
		while(Timer){
			WDR;
			SLEEP;
			if (!f){
				SegData[keta] = buff;
			} else {
				SegData[keta] = 0;
			}
			if (SW1flag){
				MenuTimer = MENU_TIMEOUT;
				SegData[keta] = buff;
				SW1flag = 0;
				SW2flag = 0;
				return n;
			} else if (SW2flag){
				MenuTimer = MENU_TIMEOUT;
				if (++n > max){
					n = min;
				}
				f = 1;
				break;
			}
		}
		f ^= 1;
	}
	return 0xFF;
}


//*******************************************************
//	7SEG 2_
//*******************************************************
void flash(void){
	uchar	buff[2];
	uchar	i;

	buff[0] = SegData[2];
	buff[1] = SegData[3];
	WDR;
	for (i = 0; i < 3; i++){
		SegData[2] = 0;
		SegData[3] = 0;
		Timer = 50;
		while(Timer)	SLEEP;
		SegData[2] = buff[0];
		SegData[3] = buff[1];
		Timer = 50;
		while(Timer)	SLEEP;
	}
}


//*******************************************************
//	7SEG LED  \
//*******************************************************
void set_hour(uchar hour){
	uchar	n;

	SegData[4] &= ~(LED_AM | LED_PM);
	if (Time12flag){
		if (hour < 0x12){
			SegData[4] |= LED_AM;
		} else {
			SegData[4] |= LED_PM;
		}
		if (hour >= 0x13){
			hour = BCD(BIN(hour) - 12);
		}
	}
	n = hour >> 4;
	if (n){
		SegData[0] = (uchar)pgm_read_byte(&(NumFont[n]));
	} else {
		SegData[0] = 0;		// [TvX
	}
	SegData[1] = (uchar)pgm_read_byte(&(NumFont[hour & 0x0F]));
}


//*******************************************************
//	A[uU[ ON
//*******************************************************
void alarm_on(void){

	PRR &= ~(1<<PRTIM0);			// ^C}OdON
	TCCR0A = (1<<WGM01);			// CTC
	TCCR0B = (1<<CS01);				// vXP[ 8
	OCR0A = 62 - 1;					// 2MHz / 8 / 62 = 4kHz
	TIMSK0 = (1<<OCIE0A);			// rv`荞݋
	DDRD |= (1<<TXD)|(1<<RXD);		// |[go
}


//*******************************************************
//	A[uU[ OFF
//*******************************************************
void alarm_off(void){

	AlarmOn = 0;
	PORTD |= (1<<TXD)|(1<<RXD);
	DDRD &= ~((1<<TXD)|(1<<RXD));
	TIMSK0 = 0;
	PRR |= (1<<PRTIM0);		// ^C}OdOFF
}


//*******************************************************
//	7SEG 邳ݒ
//*******************************************************
void set_duty(uchar duty){

	if (duty >= 100){
		OCR2B = 20;
	} else if (duty < 5){
		OCR2B = 0;
	} else {
		OCR2B = duty / 5 - 1;
	}
}


//*******************************************************
//	{^͑҂
//*******************************************************
uchar inkey(void){

	SW1flag = 0;
	SW2flag = 0;

	while(MenuTimer){
		WDR;
		SLEEP;

		if (SW1flag){
			SW1flag = 0;
			SW2flag = 0;
			return SW1;
		}
		if (SW2flag){
			SW1flag = 0;
			SW2flag = 0;
			return SW2;
		}
	}

	SW1flag = 0;
	SW2flag = 0;
	return 0;
}


//*******************************************************
//	JJYobt@̓e RTCWX^^ɕϊ
//*******************************************************
void JJY2RTC(struct RTC_TIME *rtc){
	uint	day;
	uchar	i;

	rtc->sec = 0;
	rtc->min = (JJYbuff[0] & 0x70)|((JJYbuff[0] & 0x07)<<1)|(JJYbuff[1]>>7);
	rtc->hour = ((JJYbuff[1] & 0x0C)<<2)|((JJYbuff[1] & 0x01)<<3)|((JJYbuff[2] & 0xE0)>>5);

	day = (JJYbuff[2] & 0x03) * 100
		+ ((JJYbuff[3] & 0x78)>>3) * 10
		+ ((JJYbuff[3] & 0x03)<<2)
		+ ((JJYbuff[4] & 0xC0)>>6);
	rtc->year = ((JJYbuff[5] & 0x7F)<<1)|((JJYbuff[6] & 0x80)>>7);
	for(i = 1; i < 12; i++){
		uchar	last_day;
		last_day = (char)pgm_read_byte(&MonthDays[i]);
		if ((i == 2)&&((BIN(rtc->year) % 4) == 0)){
			last_day++;
		}
		if (day <= last_day){
			break;
		} else {
			day -= last_day;
		}
	}
	rtc->month = BCD(i);
	rtc->day = BCD(day);
	rtc->week = (JJYbuff[6] & 0x38) >> 3;
}


//*******************************************************
//	RTCWX^obt@̓ePi߂
//*******************************************************
void next_min(struct RTC_TIME *rtc){
	uchar	last_day;

	rtc->min = add_BCD(rtc->min, 1);
	if (rtc->min >= 0x60){
		rtc->min = 0;
		rtc->hour = add_BCD(rtc->hour, 1);
		if (rtc->hour >= 0x24){
			rtc->hour = 0;
			rtc->day = add_BCD(rtc->day, 1);
			last_day = (char)pgm_read_byte(&MonthDays[BIN(rtc->month)]);
			if ((rtc->month == 2)&&((BIN(rtc->year) % 4) == 0)){
				last_day++;
			}
			last_day = ((last_day / 10) << 4)|(last_day % 10);
			if (rtc->day > last_day){
				rtc->day = 1;
				rtc->month = add_BCD(rtc->month, 1);
				if (rtc->month >= 0x13){
					rtc->month = 1;
					rtc->year = add_BCD(rtc->year, 1);
				}
			}
		}
	}
}


//*******************************************************
//	BCDZ
//*******************************************************
uchar add_BCD(uchar source, uchar add){

	source += add;
	if ((source & 0x0F) >= 0x0A)	source += 6;
	if (source >= 0xA0)				source += 0x60;
	return source;
}


//*******************************************************
//	BCD  oCiϊ
//*******************************************************
uchar BIN(uchar bcd){

	return (bcd >> 4) * 10 + (bcd & 0x0F);
}


//*******************************************************
//	oCi  BCDϊ
//*******************************************************
uchar BCD(uchar bin){

	return ((bin / 10) << 4) | (bin % 10);
}


//*******************************************************
//	Clock modulebǂݍ
//*******************************************************
uchar read_RTC_sec(void){
	uchar	sec;

	TWI_open();
	TWI_write(0xA2);	// X[uAhX + Write
	TWI_write(2);		// WX^ 2(Second)
	TWI_start();		// Jn
	TWI_write(0xA3);	// X[uAhX + Read
	sec = TWI_read_nack();
	TWI_close();

	return sec;
}


//*******************************************************
//	Clock module玞ԓǂݍ
//*******************************************************
void read_RTC(struct RTC_TIME *rtc){

	TWI_open();
	TWI_write(0xA2);	// X[uAhX + Write
	TWI_write(2);		// WX^ 2(Second)
	TWI_start();		// Jn
	TWI_write(0xA3);	// X[uAhX + Read
	rtc->sec = TWI_read_ack();
	rtc->min = TWI_read_ack() & 0x7F;
	rtc->hour = TWI_read_ack() & 0x3F;
	rtc->day = TWI_read_ack() & 0x3F;
	rtc->week = TWI_read_ack() & 0x07;
	rtc->month = TWI_read_ack() & 0x1F;
	rtc->year = TWI_read_nack();
	TWI_close();

	// VLrbg`FbN
	if (rtc->sec & 0x80){
		rtc->year = 0;		// 2000/01/01
		rtc->month = 1;
		rtc->day = 1;
		rtc->sec &= 0x7F;	// VLrbgNA
		// EEb͎c
	}
}


//*******************************************************
//	RTCv킹
//*******************************************************
void adjust_RTC(struct RTC_TIME *rtc){

	TWI_open();
	TWI_write(0xA2);	// X[uAhX + Write
	TWI_write(0);		// WX^ 0(Control1)
	TWI_write(0x20);	// NbNPbȉNA
	TWI_close();

	TWI_open();
	TWI_write(0xA2);	// X[uAhX + Write
	TWI_write(0);		// WX^ 0(Control1)
	TWI_write(0);		// ߂
	TWI_close();

	TWI_open();
	TWI_write(0xA2);	// X[uAhX + Write
	TWI_write(2);		// WX^ 2(Seconds)
	TWI_write(rtc->sec);
	TWI_write(rtc->min);
	TWI_write(rtc->hour);
	TWI_write(rtc->day);
	TWI_write(rtc->week);
	TWI_write(rtc->month);
	TWI_write(rtc->year);
	TWI_close();
}


//*******************************************************
// Clock module TWI Open
//*******************************************************
char TWI_open(void){
	uint	i;

	TWBR = 0;
	TWSR = 0;		// TWI clock	2MHz / (16 + 2 * TWSR) =  125kHz

	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);	// Jno
	for (i = 0; i < 10000; i++){
		if (TWCR & (1<<TWINT))	break;
	}

	if ((TWSR & TW_NO_INFO) != TW_START){
		return 1;	// ERROR
	} else {
		return 0;
	}
}


//*******************************************************
//	TWI Write
//*******************************************************
char TWI_write(uchar data){
	uint	i;

	TWDR = data;	// f[^
	TWCR = (1<<TWINT)|(1<<TWEN);
	for (i = 0; i < 10000; i++){
		if (TWCR & (1<<TWINT))	break;
	}

	if ((TWSR & TW_NO_INFO) != TW_MT_DATA_ACK){
		return 1;	// ERROR
	} else {
		return 0;
	}
}


//*******************************************************
// TWI Start
//*******************************************************
char TWI_start(void){
	uint	i;

	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);	// Jno

	for (i = 0; i < 10000; i++){
		if (TWCR & (1<<TWINT))	break;
	}

	if ((TWSR & TW_NO_INFO) != TW_REP_START){
		return 1;	// ERROR
	} else {
		return 0;
	}
}


//*******************************************************
//	TWI Read ACK
//*******************************************************
uchar TWI_read_ack(void){
	uint	i;

	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWEA);

	for (i = 0; i < 10000; i++){
		if (TWCR & (1<<TWINT))	break;
	}

	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){
		return 0;		// ERROR
	} else {
		return TWDR;	// f[^
	}
}


//*******************************************************
//	TWI Read NACK
//*******************************************************
uchar TWI_read_nack(void){
	uint	i;

	TWCR = (1<<TWINT)|(1<<TWEN);

	for (i = 0; i < 10000; i++){
		if (TWCR & (1<<TWINT))	break;
	}

	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_NACK){
		return 0;		// ERROR
	} else {
		return TWDR;	// f[^
	}
}


//*******************************************************
//	TWI Close
//*******************************************************
void TWI_close(void){

	TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN);
}
